#
#	File:		CompositeClassDriver.make
#
#	Contains:	Make file for Composite Class Driver
#
#	Version:	xxx put version here xxx
#
#	Copyright:	 1997-1998 by Apple Computer, Inc., all rights reserved.
#
MAKEFILE     = CompositeClassDriver.make
MondoBuild = {MAKEFILE}  # Make blank to avoid rebuilds when makefile is modified
Includes     = -i {USBInterfacesInternal},{USBInterfacesExternal}
SymPPC      = -sym on 
CompositeClassDriverTarget	= {USBTargets}Drivers:USBCompositeDriver

PPCCOptions  = {Includes} {SymPPC}  {NeptuneCOptions} 

LinkPPC		=	PPCLink

ObjectsPPC	=	"{USBObjects}CompositeClassDriver.c.o"		
				"{USBObjects}CompositeDriverDescription.c.o" 
				"{USBObjects}ConfigParse.c.o"

CompositeClassDriver  "{USBReleaseExtensions}USBCompositeDriver"  

"{USBReleaseExtensions}USBCompositeDriver"   "{CompositeClassDriverTarget}" 
		duplicate -y "{CompositeClassDriverTarget}"  {Targ}
		
{CompositeClassDriverTarget}		{MondoBuild}  {ObjectsPPC}	 "{USBInterfacesInternal}USBClassDriver.exp"
	delete -i "{Targ}.xcoff"
	delete -i "{Targ}.dbg"
	{LinkPPC}												
	 	-map "{USBMapDir}USBCompositeDriver.map"	 		
		-t 'ndrv'											
		-c 'usbd'											
		-o {CompositeClassDriverTarget} {SymPPC} 			
		{ObjectsPPC} 										
		-xm sharedlibrary									
		-share context										
		-@export "{USBInterfacesInternal}USBClassDriver.exp"
		"{USBLibraries}USBServicesLib" 						
		"{SharedLibraries}NameRegistryLib"					
		"{SharedLibraries}DriverLoaderLib"					
		"{SharedLibraries}DriverServicesLib" 				
		"{SharedLibraries}InterfaceLib" 					
		"{SharedLibraries}PCILib"							
		"{PPCLibraries}PPCCRuntime.o"


{CompositeClassDriverTarget}		"{USBInterfacesInternal}USBClassDriverIcons.r"	
						{MondoBuild}
	Rez														
		-i "{USBInterfacesInternal}"						
		-i "{RIncludes}"									
		"{RIncludes}Types.r"								
		"{USBInterfacesInternal}USBClassDriverIcons.r"		
		-a													
		-o {Targ}
		
{CompositeClassDriverTarget}		"{USBInterfacesInternal}PackageVersion.h"	
						"CompositeClassVersion.h"			
						"CompositeClassDriver.r"			
						{MondoBuild}
	Rez														
		-i "{USBInterfacesInternal}"						
		-i "{RIncludes}"									
		"{RIncludes}Types.r"								
		"CompositeClassDriver.r"							
		-a													
		-o {Targ}
		
"{USBObjects}CompositeDriverDescription.c.o"		"CompositeDriverDescription.c"	
										"{USBInterfacesExternal}USB.h"				
										"{USBInterfacesInternal}PackageVersion.h"	
										"CompositeClassVersion.h"					
										"CompositeClassDriver.h"
	{PPCC} CompositeDriverDescription.c -o {Targ} {PPCCOptions}

"{USBObjects}CompositeClassDriver.c.o"		"CompositeClassDriver.c"				
										"{USBInterfacesExternal}USB.h"				
										"CompositeClassDriver.h"
	{PPCC} CompositeClassDriver.c -o {Targ} {PPCCOptions}

"{USBObjects}ConfigParse.c.o"			"ConfigParse.c"								
										"{USBInterfacesExternal}USB.h"				
										"CompositeClassDriver.h"
	{PPCC} ConfigParse.c -o {Targ} {PPCCOptions}

Clean 
	Delete -i {ObjectsPPC}
	Delete -i {CompositeClassDriverTarget} 
	Delete -i "{USBReleaseExtensions}USBCompositeDriver"